#include "ClientSocket.h"
#include "Testpacket.h"
#include "PacketTypeId.h"

#include <iostream>

#ifdef WIN32
  #include <windows.h>
  #define snooze(n) Sleep(n)
#else
  #include <unistd.h>
  #define snooze(n) usleep(n * 1000);
#endif

using namespace std;
using TEmpire::ClientSocket;

int main(int argc, char *argv[]) {

  // Create connection
  ClientSocket *cs = new ClientSocket();
  if(!cs->Connect("localhost", 4000)) {
    return -1;
  }
  
  while(!cs->IsConnected()) {
    snooze(30);
  }
  
  // Create packet
  TEmpire::TestPacket *tp = new TEmpire::TestPacket();
  
  // Send packet
  cs->SendPacket(tp);
  
  cout << "Sent packet!" << endl;
  
  // Receive packets
  while(true) {
    TEmpire::Packet *packet = cs->ReceivePacket();
    
    if(packet == NULL) {
      snooze(30);
      continue;
    }
  
    cout << "Packet received!" << endl;
    
    if(packet->GetType() == TEmpire::PCID_TESTREPLYPACKET) {
      cout << "The packet has the right type! :D" << endl;
      break;
    }
    
    delete packet;
  }
  
  // Wait a short while
  snooze(500);
  
  // Clean up
  delete tp;
  delete cs;
  
  return 0;
}
