/* PacketFactory.cpp
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include "PacketFactory.h"
#include "PacketTypeId.h"
#include "TestPacket.h"
#include "TestReplyPacket.h"

using namespace TEmpire;

// Static variables
PacketFactory *PacketFactory::Instance = NULL;

std::string PacketFactory::Author = "Hellfire";
std::string PacketFactory::Name = "PacketFactory";
std::string PacketFactory::Abbreviation = "PFCT";
long PacketFactory::Count = 0;

// Constructor
PacketFactory::PacketFactory() {
}

// Get the only object of the PacketFactory class
PacketFactory *PacketFactory::GetInstance() {
  if(Instance == NULL) {
    Instance = new PacketFactory();
  }
  
  return Instance;
}

// Reconstruct a packet from a stream buffer
Packet *PacketFactory::Reconstruct(unsigned char *buffer, unsigned int bufLen) {
  unsigned char type;
  
  type = buffer[0];
  
  Packet *packet = NULL;
  
  switch(type) {
    case PCID_TESTPACKET:
      packet = new TestPacket();
      break;
    case PCID_TESTREPLYPACKET:
      packet = new TestReplyPacket();
      break;
    
    default:
      return NULL;
  }
  
  packet->ParseBuffer(buffer, bufLen);
  
  return packet;
}
