/* TestPacket.cpp
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include "TestPacket.h"
#include "PacketTypeId.h"

using namespace TEmpire;

// Static variables
std::string TestPacket::Author = "Hellfire";
std::string TestPacket::Name = "TestPacket";
std::string TestPacket::Abbreviation = "TSTP";
long TestPacket::Count = 0;

// Constructor
TestPacket::TestPacket() {
  Count++;
}

// Destructor
TestPacket::~TestPacket() {
  Count--;
}

// Return the packet's type identifier
unsigned char TestPacket::GetType() {
  return PCID_TESTPACKET;
}

unsigned long TestPacket::Length() {
  return 1;
}

unsigned long TestPacket::FillBuffer(unsigned char *buffer, 
    unsigned long bufLen) {
  // All packets start with a 16-bit type identifier and a 16-bit length. This
  // limits the maximum length of a packet to 65532 bytes, which should be
  // enough for most packets.
  
  unsigned long length = Length();
  
  // Don't allow buffers that are too small
  if(bufLen < length) {
    return 0;
  }
  
  // Add type and length to the buffer
  buffer[0] = GetType();
  
  return length;
}

// Reconstruct ourselfs from a serialized version
bool TestPacket::ParseBuffer(unsigned char *Buffer, unsigned long buflen) {
  return false;
}
