/* TestPacket.cpp
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include "TestReplyPacket.h"
#include "PacketTypeId.h"

using namespace TEmpire;

// Static variables
std::string TestReplyPacket::Author = "Hellfire";
std::string TestReplyPacket::Name = "TestReplyPacket";
std::string TestReplyPacket::Abbreviation = "TSRP";
long TestReplyPacket::Count = 0;

// Constructor
TestReplyPacket::TestReplyPacket() {
  Count++;
}

// Destructor
TestReplyPacket::~TestReplyPacket() {
  Count--;
}

// Return the packet's type identifier
unsigned char TestReplyPacket::GetType() {
  return PCID_TESTREPLYPACKET;
}

unsigned long TestReplyPacket::Length() {
  return 1;
}

unsigned long TestReplyPacket::FillBuffer(unsigned char *buffer, 
    unsigned long bufLen) {
  // All packets start with a 8-bit type identifier. For this packet type, this
  // is enough.
  
  unsigned long length = Length();
  
  // Don't allow buffers that are too small
  if(bufLen < length) {
    return 0;
  }
  
  // Add type to the buffer
  buffer[0] = GetType();
  
  return length;
}

// Reconstruct ourselfs from a serialized version
bool TestReplyPacket::ParseBuffer(unsigned char *Buffer, unsigned long buflen) {
  return false;
}
