#include "ServerSocket.h"
#include "PacketTypeId.h"
#include "TestReplyPacket.h"
#include "Map.h"


#include <iostream>

#ifdef WIN32
  #include <windows.h>
  #define snooze(n) Sleep(n)
#else
  #include <unistd.h>
  #define snooze(n) usleep(n * 1000);
#endif

using namespace std;
using TEmpire::ServerSocket;

int main(int argc, char *argv[]) {
  
  // Create a random map
  Map *map = new Map();
  map->Random(16, 16);
  
  // Create connection
  ServerSocket *ss = new ServerSocket();
  if(!ss->OpenPort(4000)) {
    delete ss;
    
    return -1;
  }
  
  // Receive packets
  while(true) {
    TEmpire::Packet *packet = ss->ReceivePacket();
    
    if(packet == NULL) {
      snooze(30);
      continue;
    }
  
    cout << "Packet received!" << endl;
    
    if(packet->GetType() == TEmpire::PCID_TESTPACKET) {
      cout << "The packet has the right type! :D" << endl;
    }

    delete packet;
    break;
  }
  
  // Send a reply
  TEmpire::Packet *packet = new TEmpire::TestReplyPacket();
  
  ss->SendPacket(packet);
  
  cout << "Sent reply." << endl;
  snooze(500);
  
  // Clean up
  delete packet;
  delete ss;
  delete map;
  
  return 0;
}
